﻿
// class agentDialogue{
agentDialogue=function(options){
	this.setAgentDialogue=function(options, init){
		options=options=UTIL.options2json(options);
		if('perso' in options){
			if(options.perso instanceof Perso){
				this.perso=options.perso;
			}
			else if(!this.perso){
				this.perso=new Perso(options.perso);
			}
			else{
				this.perso.setPerso(options.perso);
			}
		}
		
		if(!this.message){
			this.message=new Message();
		}
		
		if('message' in options){
			if(options.message instanceof Message){
				this.message=options.message;
			}
			else{
				this.message.setMessage(options.message);
			}
			this.messageXML=this.message.messageXML;
		}
		
		if('XML' in options){
			this.XML=options.XML;
			if(!this.perso){
				this.perso=new Perso(options);
			}
			else{
				this.perso.setPerso(options);
			}
			this.messageXML=null;
			this.nextMessage();
		}
		
		if(!(this.perso)){//personnage muet autorisé
			throw("Aucun élément fourni (options.perso ou options.XML) pour modifier l'instance d'agentDialogue");
		}
		UTIL.setOptions(this, options, agentDialogue.CONST.options_defaut);
		this.initialisation();
	}
	
	this.initialisation=function(){
		this.perso.initialisation();
		this.message.initialisation();
		if(PROC){PROC.setObjet(this.name, this);}
	}
	
	this.nextMessage=function(){
		this.messageXML=PROC.next(this.messageXML, this.XML);
		if(!this.messageXML){
			this.fin();
			return;
		}
		switch(this.messageXML.tagName.toLowerCase()){
			case 'message':
				this.message.setMessage(this.messageXML);
			break;
			case 'defaut':
				this.nextMessage();
			break;
		}
		return this.messageXML;
	}
	
	this.syncAction=function(name){//pour résoudre le problème de la portée de ma variable name
		if(!opts){var opts={};}
		var that=this;
		this.message.actions[name]=function(){that.execute(name, opts);};
	}
	
	this.syncPersoMessage=function(){
		var that=this;
		for(var name in this.perso.raccourcis){
			this.syncAction(name, {});//raccourci actionnable par balises dans le message
		}
	}
	
	this.addActions=function(actions){
		if(!this.actions){this.actions={};}
		for(var name in actions){
			this.actions[name]=actions[name];
		}
		if(this.message){this.syncPersoMessage();}
	}
	
	this.addRaccourcis=function(raccourcis){//les raccourcis doivent être ajouté au message sous forme d'actions
		this.perso.addRaccourcis(raccourcis);
		if(this.message){this.syncPersoMessage();}
	}
	
	this.execute=function(name){
		if(!opts){var opts={};}
		if(this.perso.execute(name)){return true;}
		else{
			if(name in this.actions){
				this.actions[action](opts);
			}
		}
	}
	
	this.start=function(){
		this.fini=false;
		this.perso.start();
		this.message.start();
		this.loop();
	}
	
	this.stop=function(){
		this.perso.stop();
		this.message.stop();
	}
	
	this.update=function(){
		if(!this.message.fini && this.perso.fini){this.fini=false;}
		if(this.pause || this.fini){//même condition que Perso
			return;
		}
		if(this.message.defile && !this.message.pause){
			if(!this.parle){
				this.execute("parle");
				this.parle=true;
			}
		}
		else{
			if(this.parle){
				this.execute('chut');
				this.parle=false;
			}
		}
		if(this.message.fini){
			this.nextMessage();
			if(this.message){
				this.message.start();
			}
			else{
				this.fin();
			}
		}
	}
	
	this.loop=function(){
		if(this.pause || this.fini){return;}
		var that=this;
		window.requestAnimationFrame(function(){that.loop()});
		
		this.update();
	}
	
	this.fin=function(){
		this.perso.fin();
		this.message.fin();
		this.fini=true;
	}
	
	
	this.dire=function(texte){
		var that=this;
		that.execute("parle");
		this.message.setMessage(texte);
		this.message.triggerFin=function(){that.execute("chut");};
		this.message.start();
	}
	
	// constructor(options){
	UTIL.setOptions(this, agentDialogue.CONST.options_defaut);
	this.setAgentDialogue(options);
	this.syncPersoMessage();
	// }
	
}
agentDialogue.CONST={
	options_defaut : {
		name:undefined,
		parle:false,
		fini:false,
		transition:'fade'
	}
}